;=====================================================================
;                                CTEXT.LSP
;
;     This routine writes a string around a circle defined by center
;     and radius.
;     Once the center, radius, text height and text have been
;     entered, the routine will write every character from the
;     string as a separated entity using the "TEXT M" command.
;
;     Written by Juan S. Merelo (04/28/91).
;=====================================================================
(DEFUN C:CTEXT ()                          ;Main Routine
 (GRAPHSCR)                                ;On Graphics screen
 (SETQ 2PI (* 2 PI))     
 (SETQ PI2 (/ PI 2))
 (SETQ RAD (/ 180 PI))                     ;To convert radians to degrees
 (SETQ I 0)                                ;Start of loop limit var.
 (SETQ E 2PI)                              ;End of loop limit var.
 (SETQ ZZ 1)                               ;Start of string char. counter
 (SETQ ORG (GETPOINT "Center : "))         ;Get center
 (SETQ R1 (GETDIST  ORG "\nRadius : "))    ;Get Radius
 (SETQ TH (GETDIST ORG "\nText height :")) ;Get Text Height
 (SETQ TXT (GETSTRING "\nText :"))         ;Get String
 (SETQ OLDECHO (GETVAR "CMDECHO"))         ;Store value of Echo variable
 (PROMPT "\nPlease wait...")     
 (SETVAR "CMDECHO" 0)                      ;Eliminates echo on every command
 (SETQ TXL (STRLEN TXT))                   ;Lenght of string entered
 (SETQ H (/ 2PI TXL))                      ;How many degrees between character
 (WHILE (<= I E)                           ;Loop from 0 to 6.28...
        (SETQ XX (* R1 (COS I)))           ;Cal. of X coord.
         (SETQ YY (* R1 (SIN I)))          ;Cal. of Y coord.
          (SETQ PT (POLAR ORG PI XX))      ;Point of X coord.
           (SETQ PT (POLAR PT PI2 YY))     ;Point of circle
            (SETQ LT (SUBSTR TXT ZZ 1))    ;Get next char. of string
           (SETQ TA (* (- PI2 I) RAD))     ;Angle of the char
          (SETQ I (+ I H))                 ;Next angle (loop)
         (SETQ ZZ (1+ ZZ))                 ;Counter + 1
        (COMMAND "TEXT" "M" PT TH TA LT)   ;Write text 
        )
     (SETVAR "CMDECHO" OLDECHO)            ;Restores echo on every command
     (PROMPT "  Done.")
)
